map_width = 1440
map_height = 2160

require "camera"
require "enemy"


function map_load()
	--JUMPER STUFF
	jumper = require "jumper.jumper"

	--ATL STUFF
	loader = require("atl.loader")
	loader.path = "maps/"
	map = loader.load("example.tmx")
	tx = 0
	ty = 0
	scale = 1
	map:setDrawRange(0,0,map_width,map_height)
	
	--ATC STUFF
	entity = require "atc.atc"
	player_object_width = 30 
	player_object_height = 30
	player = {}
		player.x = 48
		player.y = 48
		player.xvel = 0
		player.yvel = 0
		player.speed = 25
		player.friction = 3.5
		player.object  = entity.new(48,48,player_object_width,player_object_height,map,terrain)
		player.pic = love.graphics.newImage("images/tile0.png")
		
	enemy_load()
	
	--Collision detection and resolution
	function player.object:isResolvable(side,tile,gx,gy)
		local tp = tile.properties
		
		if tp.obstacle then
			if side == "bottom" then player.yvel = 0 end
			if side == "top" then player.yvel = 0 end
			if side == "right" then player.xvel = 0 end
			if side == "left" then player.xvel = 0 end
			return true
		end
	end	
	
	--MORE JUMPER STUFF
	collision_map_maker = require "collision_map"
	
	-- Creates a collision map from the "Collision" layer
	collision_map = collision_map_maker.create(map, 'ground', 'collision')
	
	--initializing Jumper
	searchMode = 'DIAGONAL' -- whether or not diagonal moves are allowed
	heuristics = {'MANHATTAN','EUCLIDIAN','DIAGONAL','CARDINTCARD'} -- valid distance heuristics names
	current_heuristic = 1 -- indexes the chosen heuristics within 'heuristics' table
	filling = false -- whether or not returned paths will be smoothed
	postProcess = false -- whether or not the grid should be postProcessed
	pather = Jumper(collision_map,0, postProcess) -- Inits Jumper
	pather:setMode(searchMode)
	pather:setHeuristic(heuristics[current_heuristic])
	pather:setAutoFill(filling)
	drawPath = false  -- whether or not the path will be drawn
	
	
	
end

function map_update(dt)

	player.x = player.x + player.xvel
	player.y = player.y + player.yvel

	player.xvel = player.xvel * (1-math.min(dt*player.friction,1))
	player.yvel = player.yvel * (1-math.min(dt*player.friction,1))
	
	enemy_update(x,y,dt)
	
	--Player Moving
	if love.keyboard.isDown("d") and 
	player.xvel < 100 then
		player.xvel = player.xvel + player.speed * dt	
	end

	if love.keyboard.isDown("a") and 
	player.xvel > - 100 then
		player.xvel = player.xvel - player.speed * dt	
	end
	
	if love.keyboard.isDown("w") and 
	player.yvel > - 100 then
		player.yvel = player.yvel - player.speed * dt	
	end
	
	if love.keyboard.isDown("s") and 
	player.yvel < 100 then
		player.yvel = player.yvel + player.speed * dt	
	end
	
	--atc move function
	player.object:move(player.xvel,player.yvel)
	
	
	--player collides with world edges - replace this with Tiled Collisions
	if player.object.x < 0 then
		player.object.x = 0
	end
	
	if player.object.x + player.object.w > map_width then
		player.object.x = map_width - player.object.w
	end
	
	if player.object.y < 0 then
		player.object.y = 0
	end
	
	if player.object.y + player.object.h > map_height then
		player.object.y = map_height - player.object.h
	end
	
	
end

function map_draw()
	local ftx, fty = math.floor(tx), math.floor(ty)
	love.graphics.push()
	love.graphics.scale(scale)
	love.graphics.translate(ftx,fty)
	map:draw()
	love.graphics.pop()
	
	--player mouse look and drawing
	mousex, mousey = camera:mousePosition()
	local rot = math.atan2(mousey - player.object.y, mousex - player.object.x)
	
	love.graphics.draw(player.pic,player.object.x + (player.object.w/2),player.object.y + (player.object.h/2),rot,1,1,player.pic:getWidth()/2,player.pic:getHeight()/2)
	
	enemy_draw()
	
	--player.object:draw("fill")
	
	
	
end