camera = {}
camera.x = 0
camera.y = 0
camera.scaleX = 1
camera.scaleY = 1
camera.rotation = 0

function camera:set()
love.graphics.push()
love.graphics.rotate(-self.rotation)
love.graphics.scale(1 / self.scaleX, 1 / self.scaleY)
love.graphics.translate(-self.x, -self.y)
end

function camera:unset()
love.graphics.pop()
end

function camera:move(dx, dy)
self.x = self.x + (dx or 0)
self.y = self.y + (dy or 0)
end

function camera:rotate(dr)
self.rotation = self.rotation + dr
end

function camera:scale(sx, sy)
sx = sx or 1
self.scaleX = self.scaleX * sx
self.scaleY = self.scaleY * (sy or sx)
end

function camera:setPosition(x, y)
self.x = x or self.x
self.y = y or self.y
end

function camera:setScale(sx, sy)
self.scaleX = sx or self.scaleX
self.scaleY = sy or self.scaleY
end

function camera:mousePosition()
  return love.mouse.getX() * self.scaleX + self.x, love.mouse.getY() * self.scaleY + self.y
end

function camera_follow()
	--Camera follows player on the X--
	if player.object.x > love.graphics.getWidth() / 2 then
		camera.x = player.object.x - love.graphics.getWidth() / 2
	end
	
	--Camera follows player on the Y--
	if player.object.y > love.graphics.getHeight() / 2 then
		camera.y = player.object.y - love.graphics.getHeight() / 2
	end
		
	--Camera boundary for the X axis--
	if player.object.x > love.graphics.getWidth() / 2 and 
		camera.x > map_width - love.graphics.getWidth() then
		camera.x = map_width - love.graphics.getWidth()
	end
		
	--Camera boundary for the Y axis--
	if player.y > love.graphics.getHeight() / 2 and 
		camera.y > map_height - love.graphics.getHeight() then
		camera.y = map_height - love.graphics.getHeight()
	end
end