local g = love.graphics

enemies = {}
enemy_count = 100
enemy_speed = math.random() * 100

function enemy_load()
	for i=1,enemy_count do
		enemy = {}		
		enemy.pic = g.newImage("images/enemy.png")
		enemy.x = math.random(g.getWidth(), map_width - enemy.pic:getWidth())
		enemy.y = math.random(g.getHeight(), map_height - enemy.pic:getHeight())
		enemy.tileX = 0
		enemy.tileY = 0
		enemy.vx = enemy_speed
		enemy.vy = enemy_speed
		enemy.health = 6
		enemy.damage = 2
		enemy.vision = player.x + 720
		enemy.rot = 0
		enemy.radius = 25
		enemy.mass = 10
		table.insert(enemies,enemy)
	end
end



function enemy_update(x,y,dt)
	for i,v in ipairs(enemies) do
		local dx = player.x - v.x
		local dy = player.y - v.y
		local angle = math.atan2(dy,dx)
		--DISTANCE FORMULA TO CALCULATE DISTANCE BETWEEN PLAYER AND AN ENEMY--
		distance_between = math.sqrt((player.x - v.x)^2 + (player.y - v.y)^2)
		
	for i=1, #enemies-1 do
		local partA = enemies[i]
		for j=i+1, #enemies do
			local partB = enemies[j]
				circleReaction(partA, partB)
		end
	end	
	
		--CHASE THE PLAYER AND LOOK AT PLAYER--
		if distance_between <= v.vision then
			v.x = v.x + v.vx * dt * math.cos(angle)
			v.y = v.y + v.vx * dt * math.sin(angle)
			v.rot = math.atan2(player.y - v.y, player.x - v.x)
		
		--[[
		else
			patrol here
			]]--
		end
		
		--Kill or infect the player--
		if distance_between <= 10 then
			player.pic = g.newImage("images/enemy.png")
		end
		
		--Bullets collide with enemies and kill them--
		--[[for a,b in ipairs(bullets) do
			if b.x < v.x + enemy.pic:getWidth()/2 and 
			b.y < v.y + enemy.pic:getHeight()/2 and
            b.x > v.x - enemy.pic:getWidth()/2 and
			b.y > v.y - enemy.pic:getHeight()/2 then
				v.health = v.health - 1
			if v.health <= 0 then
				table.remove(enemies,i)
			end	
				--KILL BULLETS WHEN THEY HIT THE ENEMY--
				table.remove(bullets, bullet[i])
			end			
		end]]--
	end
end



function enemy_draw()
	for i,v in ipairs(enemies) do
		--g.circle("line",v.x,v.y,enemy.vision,128)
		--g.circle("line", v.x, v.y, v.radius)
		g.draw(enemy.pic, v.x,v.y,v.rot,1,1,enemy.pic:getWidth()/2,enemy.pic:getHeight()/2)
	end
end



--CIRCLE COLLISION FUNCTIONS

function checkDistColl(circleA, circleB)
    local dist = math.sqrt((circleA.x - circleB.x)^2 + (circleA.y - circleB.y)^2)
    return dist <= circleA.radius + circleB.radius
end

function checkCircleColl(circleA, circleB)
    --First check if their bounding boxes collide
    if math.abs(circleA.x - circleB.x) < circleA.radius + circleB.radius or
       math.abs(circleA.y - circleB.y) < circleA.radius + circleB.radius then
        -- Now check if they actually overlap
        return checkDistColl(circleA, circleB)
    end
end

function circleReaction(circleA, circleB)
    if checkCircleColl(circleA, circleB) then
        -- Create new velocities
        -- local newVelX1 = (circleA.vx * (circleA.mass - circleB.mass) + (2 * circleB.mass * circleB.vx)) / (circleA.mass + circleB.mass)
        -- local newVelY1 = (circleA.vy * (circleA.mass - circleB.mass) + (2 * circleB.mass * circleB.vy)) / (circleA.mass + circleB.mass)
        -- local newVelX2 = (circleB.vx * (circleB.mass - circleA.mass) + (2 * circleA.mass * circleA.vx)) / (circleA.mass + circleB.mass)
        -- local newVelY2 = (circleB.vy * (circleB.mass - circleA.mass) + (2 * circleA.mass * circleA.vy)) / (circleA.mass + circleB.mass)
		local vxTotal = circleA.vx - circleB.vx
        local vyTotal = circleA.vy - circleB.vy        
        local newVelX1 = (circleA.vx * (circleA.mass - circleB.mass) + (2 * circleB.mass * circleB.vx)) / (circleA.mass + circleB.mass)
        local newVelY1 = (circleA.vy * (circleA.mass - circleB.mass) + (2 * circleB.mass * circleB.vy)) / (circleA.mass + circleB.mass)
        local newVelX2 = vxTotal + newVelX1
        local newVelY2 = vyTotal + newVelY1
        
        
        -- Move the circles so that they don't overlap
        local midpointX = (circleA.x + circleB.x)/2
        local midpointY = (circleA.y + circleB.y)/2
        local dist = math.sqrt((circleA.x - circleB.x)^2 + (circleA.y - circleB.y)^2)
        circleA.x = midpointX + circleA.radius * (circleA.x - circleB.x)/dist
        circleA.y = midpointY + circleA.radius * (circleA.y - circleB.y)/dist
        circleB.x = midpointX + circleB.radius * (circleB.x - circleA.x)/dist
        circleB.y = midpointY + circleB.radius * (circleB.y - circleA.y)/dist
        
        -- Update the velocities
        circleA.vx = newVelX1
        circleB.vy = newVelY1
        circleB.vx = newVelX2
        circleB.vy = newVelY2
    end
end